﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Interactivity;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Linq;

namespace SL.SelectCheckbox
{
    public class AutoRowEditBehavior:Behavior<RadGridView>
    {


        public string TargetUniqueNameColumn
        {
            get { return (string)GetValue(TargetUniqueNameColumnProperty); }
            set { SetValue(TargetUniqueNameColumnProperty, value); }
        }

        // Using a DependencyProperty as the backing store for TargetUniqueNameColumn. 
        public static readonly DependencyProperty TargetUniqueNameColumnProperty =
            DependencyProperty.Register("TargetUniqueNameColumn", typeof(string), typeof(AutoRowEditBehavior), new PropertyMetadata(string.Empty));

        

        protected override void OnAttached()
        {
            base.OnAttached();

            this.AssociatedObject.RowLoaded += new EventHandler<Telerik.Windows.Controls.GridView.RowLoadedEventArgs>(AssociatedObject_RowLoaded);
        }

        void AssociatedObject_RowLoaded(object sender, Telerik.Windows.Controls.GridView.RowLoadedEventArgs e)
        {
            var row = e.Row as GridViewRow;
            if (row!=null)
            {
                row.AddHandler(FrameworkElement.MouseLeftButtonDownEvent, new MouseButtonEventHandler(row_MouseLeftButtonDown), true);
            }
        }

        void row_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            var row = sender as GridViewRow;

            if (row != null)
            {
                var cell = row.Cells.Where(c => c.Column.UniqueName == this.TargetUniqueNameColumn).FirstOrDefault() as GridViewCell;

                if (cell != null && FocusManager.GetFocusedElement()==cell)
                {
                    cell.BeginEdit();
                }
            }
        }


    }
}
